gtk3-0.15.10: Binding to the Gtk+ 3 graphical user interface library

Maintainer | gtk2hs-users@lists.sourceforge.net
Stability | provisional
Portability | portable (depends on GHC)
Safe Haskell | None
Language | Haskell98

Graphics.UI.Gtk.Abstract.IMContext

Contents

- Class Hierarchy
- Types
- Methods
- Signals

Description

Base class for input method contexts

Synopsis

- data IMContext
- class GObjectClass o => IMContextClass o
- castToIMContext :: GObjectClass obj => obj -> IMContext
- gTypeIMContext :: GType
- toIMContext :: IMContextClass o => o -> IMContext
- imContextSetClientWindow :: IMContextClass self => self -> Maybe DrawWindow -> IO ()
- imContextGetPreeditString :: (IMContextClass self, GlibString string) => self -> IO (string, [[PangoAttribute]], Int)
- imContextFilterKeypress :: IMContextClass self => self -> EventM EKey Bool
- imContextFocusIn :: IMContextClass self => self -> IO ()
- imContextFocusOut :: IMContextClass self => self -> IO ()
- imContextReset :: IMContextClass self => self -> IO ()
- imContextSetCursorLocation :: IMContextClass self => self -> Rectangle -> IO ()
- imContextSetUsePreedit :: IMContextClass self => self -> Bool -> IO ()
- imContextSetSurrounding :: (IMContextClass self, GlibString string) => self -> string -> Int -> IO ()
- imContextGetSurrounding :: (IMContextClass self, GlibString string) => self -> IO (Maybe (string, Int))
- imContextDeleteSurrounding :: IMContextClass self => self -> Int -> Int -> IO Bool
- imContextPreeditStart :: IMContextClass self => Signal self (IO ())
- imContextPreeditEnd :: IMContextClass self => Signal self (IO ())
- imContextPreeditChanged :: IMContextClass self => Signal self (IO ())
- imContextCommit :: (IMContextClass self, GlibString string) => Signal self (string -> IO ())
- imContextRetrieveSurrounding :: IMContextClass self => Signal self (IO Bool)
- imContextDeleteSurrounding' :: IMContextClass self => Signal self (Int -> Int -> IO Bool)

# Class Hierarchy

    | GObject
    | +----IMContext
    | +----IMContextSimple
    | +----IMMulticontext

# Types

data IMContext Source #

#### Instances

Instances details

Eq IMContext Source # |
Instance details Defined in Graphics.UI.Gtk.Types Methods (==) :: IMContext -> IMContext -> Bool Source # (/=) :: IMContext -> IMContext -> Bool Source #
Ord IMContext Source # |

Instance details

Defined in Graphics.UI.Gtk.Types

Methods

compare :: IMContext -> IMContext -> Ordering Source #

(<) :: IMContext -> IMContext -> Bool Source #

(<=) :: IMContext -> IMContext -> Bool Source #

(>) :: IMContext -> IMContext -> Bool Source #

(>=) :: IMContext -> IMContext -> Bool Source #

max :: IMContext -> IMContext -> IMContext Source #

min :: IMContext -> IMContext -> IMContext Source #

GObjectClass IMContext Source # |
Instance details Defined in Graphics.UI.Gtk.Types Methods toGObject :: IMContext -> GObject Source # unsafeCastGObject :: GObject -> IMContext Source #
IMContextClass IMContext Source # |
Instance details Defined in Graphics.UI.Gtk.Types

class GObjectClass o => IMContextClass o Source #

#### Instances

Instances details

IMContextClass IMContext Source # |
Instance details Defined in Graphics.UI.Gtk.Types
IMContextClass IMContextSimple Source # |
Instance details Defined in Graphics.UI.Gtk.Types
IMContextClass IMMulticontext Source # |
Instance details Defined in Graphics.UI.Gtk.Types

castToIMContext :: GObjectClass obj => obj -> IMContext Source #

gTypeIMContext :: GType Source #

toIMContext :: IMContextClass o => o -> IMContext Source #

# Methods

imContextSetClientWindow Source #

Arguments

:: IMContextClass self |
=> self |
-> Maybe DrawWindow | `window` - the client window. `Nothing` indicates that the previous client window no longer exists.
-> IO () |

Set the client window for the input context; this is the `DrawWindow` in which the input appears. This window is used in order to correctly position status windows, and may also be used for purposes internal to the input method.

imContextGetPreeditString Source #

Arguments

:: (IMContextClass self, GlibString string) |
=> self |
-> IO (string, [[PangoAttribute]], Int) | `(str, attrs, cursorPos)` Retrieved string, attributes to apply to the string, position of cursor.

Retrieve the current preedit string for the input context, and a list of attributes to apply to the string. This string should be displayed inserted at the insertion point.

imContextFilterKeypress Source #

Arguments

:: IMContextClass self |
=> self |
-> EventM EKey Bool | returns `True` if the input method handled the key event.

Allow an input method to internally handle key press and release events. If this function returns `True`, then no further processing should be done for this key event.

imContextFocusIn :: IMContextClass self => self -> IO () Source #

Notify the input method that the widget to which this input context corresponds has gained focus. The input method may, for example, change the displayed feedback to reflect this change.

imContextFocusOut :: IMContextClass self => self -> IO () Source #

Notify the input method that the widget to which this input context corresponds has lost focus. The input method may, for example, change the displayed feedback or reset the contexts state to reflect this change.

imContextReset :: IMContextClass self => self -> IO () Source #

Notify the input method that a change such as a change in cursor position has been made. This will typically cause the input method to clear the preedit state.

imContextSetCursorLocation Source #

Arguments

:: IMContextClass self |
=> self |
-> Rectangle | `area` - new location
-> IO () |

Notify the input method that a change in cursor position has been made. The location is relative to the client window.

imContextSetUsePreedit Source #

Arguments

:: IMContextClass self |
=> self |
-> Bool | `usePreedit` - whether the IM context should use the preedit string.
-> IO () |

Sets whether the IM context should use the preedit string to display feedback. If `usePreedit` is `False` (default is `True`), then the IM context may use some other method to display feedback, such as displaying it in a child of the root window.

imContextSetSurrounding Source #

Arguments

:: (IMContextClass self, GlibString string) |
=> self |
-> string | `text` - text surrounding the insertion point, as UTF-8. the preedit string should not be included within `text`.
-> Int | `cursorIndex` - the index of the insertion cursor within `text`.
-> IO () |

Sets surrounding context around the insertion point and preedit string. This function is expected to be called in response to the `imContextRetrieveSurrounding` signal, and will likely have no effect if called at other times.

imContextGetSurrounding Source #

Arguments

:: (IMContextClass self, GlibString string) |
=> self |
-> IO (Maybe (string, Int)) | `Maybe (text,cursorIndex)` Text holding context around the insertion point and the index of the insertion cursor within `text`. `Nothing` if no surrounding text was provided.

Retrieves context around the insertion point. Input methods typically want context in order to constrain input text based on existing text; this is important for languages such as Thai where only some sequences of characters are allowed.

This function is implemented by emitting the `imContextRetrieveSurrounding` signal on the input method; in response to this signal, a widget should provide as much context as is available, up to an entire paragraph, by calling `imContextSetSurrounding`. Note that there is no obligation for a widget to respond to the `imContextRetrieveSurrounding` signal, so input methods must be prepared to function without context.

imContextDeleteSurrounding Source #

Arguments

:: IMContextClass self |
=> self |
-> Int | `offset` - offset from cursor position in chars; a negative value means start before the cursor.
-> Int | `nChars` - number of characters to delete.
-> IO Bool | returns `True` if the signal was handled.

Asks the widget that the input context is attached to to delete characters around the cursor position by emitting the `imContextDeleteSurrounding` signal.

In order to use this function, you should first call `imContextGetSurrounding` to get the current context, and call this function immediately afterwards to make sure that you know what you are deleting. You should also account for the fact that even if the signal was handled, the input context might not have deleted all the characters that were requested to be deleted.

This function is used by an input method that wants to make substitutions in the existing text in response to new input. It is not useful for applications.

# Signals

imContextPreeditStart :: IMContextClass self => Signal self (IO ()) Source #

This signal is emitted when a new preediting sequence starts.

imContextPreeditEnd :: IMContextClass self => Signal self (IO ()) Source #

This signal is emitted when a preediting sequence has been completed or canceled.

imContextPreeditChanged :: IMContextClass self => Signal self (IO ()) Source #

This signal is emitted whenever the preedit sequence currently being entered has changed. It is also emitted at the end of a preedit sequence, in which case `imContextGetPreeditString` returns the empty string.

imContextCommit :: (IMContextClass self, GlibString string) => Signal self (string -> IO ()) Source #

This signal is emitted when a complete input sequence has been entered by the user. This can be a single character immediately after a key press or the final result of preediting. Parameters:

`str` - the completed character(s) entered by the user

imContextRetrieveSurrounding :: IMContextClass self => Signal self (IO Bool) Source #

This signal is emitted when the input method requires the context surrounding the cursor. The callback should set the input method surrounding context by calling `imContextSetSurrounding`.

Returns True if the signal was handled.

imContextDeleteSurrounding' :: IMContextClass self => Signal self (Int -> Int -> IO Bool) Source #

This signal is emitted when the input method needs to delete all or part of the context surrounding the cursor. Parameters:

`offset` - the character offset from the cursor position of the text to be deleted. A negative value indicates a position before the cursor.

`n_chars` - the number of characters to be deleted.

Returns True if the signal was handled.